﻿Imports System.IO
Imports System.Xml

Namespace Sonora.Console.Framework.API.Xml

    Public Class XmlFacade

        Private Shared _buffer As StringWriter
        Private Shared _writer As XmlWriter
        Private Shared _settings As XmlWriterSettings
        Public Sub New()
            _settings = New XmlWriterSettings With {.Indent = True}
        End Sub

        Public Function start() As XmlFacade
            _buffer = New StringWriter
            _writer = XmlWriter.Create(_buffer, _settings)
            _writer.WriteStartDocument()
            Return Me
        End Function

        Public Function [end]() As String
            _writer.WriteEndDocument()
            _writer.Flush()
            Dim x = _buffer.ToString
            Return x
        End Function

        Public Function open(ByVal node As String) As XmlFacade
            _writer.WriteStartElement(node)
            Return Me
        End Function
        Public Function val(ByVal content As Object) As XmlFacade
            _writer.WriteValue(content)
            Return Me
        End Function

        Public Function close() As XmlFacade
            _writer.WriteEndElement()
            Return Me
        End Function

        Public Function attr(ByVal name As String, ByVal content As Object) As XmlFacade
            _writer.WriteAttributeString(name, content.ToString)
            Return Me
        End Function

    End Class

End Namespace