﻿Imports System.Net
Imports System.Web.Script.Serialization

Namespace Sonora.Console.Framework.Extensions

	Public Module MiscExtensions

		<System.Runtime.CompilerServices.Extension> _
		Public Function ToInt(ByVal theString As String, Optional ByVal defaultNumber As Int32 = 0) As Int32
			Dim number As Int32
			Dim success = Int32.TryParse(theString, number)
			Return If(success, number, defaultNumber)
		End Function

		<System.Runtime.CompilerServices.Extension> _
		Public Function ToBool(ByVal theString As String) As Boolean
			Dim value As Boolean
			Dim success = Boolean.TryParse(theString, value)
			Return success AndAlso value
		End Function

		<System.Runtime.CompilerServices.Extension> _
		Public Function DownloadJson(Of T)(ByVal client As WebClient, ByVal url As String) As T
			Dim data As String
			Try
				data = client.DownloadString(url)
			Catch
				data = Nothing
            End Try

			If String.IsNullOrEmpty(data) Then
				Return Nothing
			End If

			Dim serializer = New JavaScriptSerializer With {.MaxJsonLength = Int32.MaxValue, .RecursionLimit = 100}
			Dim obj = serializer.Deserialize(Of T)(data)
			Return obj
		End Function

	End Module

End Namespace