﻿Imports System.Configuration
Imports Microsoft.ClearScript.Windows
Imports Sonora.Console.Framework.Extensions

Namespace Sonora.Console.Framework

    Public Class SonoraConfig
        Public Const CurrentLanguage As String = "language"
        Public Const OutputAutoClear As String = "output-autoclear"
        Public Const OutputAppendNewLine As String = "output-appendnewline"
        Public Const OutputDefaultFileName As String = "output-defaultfile"
        Public Const FolderOutput As String = "folder-output"
        Public Const FolderInput As String = "folder-input"

        Public Shared Function Load() As SonoraSettings
            Dim language = If(ConfigurationManager.AppSettings(CurrentLanguage), "")
            Dim autoclear = ConfigurationManager.AppSettings(OutputAutoClear).ToBool()
            Dim addnewline = ConfigurationManager.AppSettings(OutputAppendNewLine).ToBool()
            Dim outputfolder = If(ConfigurationManager.AppSettings(FolderOutput), "")
            Dim inputfolder = If(ConfigurationManager.AppSettings(FolderInput), "")
            Dim defaultfilename = If(ConfigurationManager.AppSettings(OutputDefaultFileName), "")

            Dim settings = New SonoraSettings With {.AppendNewLine = addnewline, .AutoClear = autoclear}
            If String.Equals(language, "vb", StringComparison.InvariantCultureIgnoreCase) Then
                settings.Engine = New VBScriptEngine()
            End If

            If Not String.IsNullOrWhiteSpace(outputfolder) Then
                settings.OutputFolder = outputfolder
            End If
            If Not String.IsNullOrWhiteSpace(inputfolder) Then
                settings.InputFolder = inputfolder
            End If
            If Not String.IsNullOrWhiteSpace(defaultfilename) Then
                settings.DefaultFileName = defaultfilename
            End If
            Return settings
        End Function

    End Class

End Namespace