﻿Imports System.IO
Imports Microsoft.ClearScript
Imports Sonora.Console.Framework.API.Xml

Namespace Sonora.Console.Framework

    Public Class SonoraConsole
        Public Shared Sub Initialize()
            Dim settings = SonoraConfig.Load()

            settings.Engine.AddHostObject("out", New SonoraOutput(settings))
            settings.Engine.AddHostObject("xml", New XmlFacade)
            'settings.Engine.AddHostType("dt", typeof(DateTime));
            settings.Engine.AddHostObject("dotnet", New HostTypeCollection("mscorlib", "System.Core"))

            If Not settings.Engine.Name.ToLower().Contains("vb") Then
                settings.Engine.Execute("String.prototype.contains = function(s) { return this.indexOf(s) != -1; };")
            End If

            ' Set references for the outside world
            SonoraConsole.Settings = settings
            ScriptEngine = settings.Engine
            Output = settings.Buffer
            Language = settings.Engine.Name.Replace("Engine", "").Replace("V8Script", "JavaScript (V8)")
        End Sub

        Private Shared privateScriptEngine As ScriptEngine
        Public Shared Property ScriptEngine As ScriptEngine
            Get
                Return privateScriptEngine
            End Get
            Private Set(ByVal value As ScriptEngine)
                privateScriptEngine = value
            End Set
        End Property
        Private Shared privateOutput As StringWriter
        Public Shared Property Output As StringWriter
            Get
                Return privateOutput
            End Get
            Private Set(ByVal value As StringWriter)
                privateOutput = value
            End Set
        End Property

        Private Shared privateSettings As SonoraSettings
        Public Shared Property Settings As SonoraSettings
            Get
                Return privateSettings
            End Get
            Private Set(ByVal value As SonoraSettings)
                privateSettings = value
            End Set
        End Property
        Private Shared privateLanguage As String
        Public Shared Property Language As String
            Get
                Return privateLanguage
            End Get
            Private Set(ByVal value As String)
                privateLanguage = value
            End Set
        End Property

    End Class
End Namespace