﻿Imports Sonora.Console.Framework

Namespace Sonora.Console.Presenters

    Public Class MainWindowPresenter
        Inherits PresenterBase

        Public Sub New()
            HeaderText = "Sonora Console"
            Command = "var x = 4" & vbCrLf & "out.print(x+1)"
            OutputText = ""
            ScriptingLanguage = SonoraConsole.Language
        End Sub

        Private _headerText As String
        Public Property HeaderText As String
            Get
                Return _headerText
            End Get
            Set(ByVal value As String)

                _headerText = value
                OnPropertyChanged("HeaderText")
            End Set
        End Property

        Private _command As String
        Public Property Command As String
            Get
                Return _command
            End Get
            Set(ByVal value As String)
                _command = value
                OnPropertyChanged("Script")
            End Set
        End Property

        Private _scriptingLanguage As String
        Public Property ScriptingLanguage As String
            Get
                Return _scriptingLanguage
            End Get
            Set(ByVal value As String)

                _scriptingLanguage = value
                OnPropertyChanged("ScriptingLanguage")
            End Set
        End Property

        Private _outputText As String
        Public Property OutputText As String
            Get
                Return _outputText
            End Get
            Set(ByVal value As String)
                _outputText = value
                OnPropertyChanged("OutputText")
            End Set
        End Property

        Public Sub Confirm()
            Try
                SonoraConsole.ScriptEngine.Execute(Command)
                OutputText = SonoraConsole.Output.ToString()
            Catch e As Exception
                OutputText = e.Message
            End Try
        End Sub

        Public Sub ShowInFolder()
            Process.Start(SonoraConsole.Settings.OutputFolder)
        End Sub

    End Class

End Namespace